﻿using System;
using System.ServiceProcess;
using System.Diagnostics;
using System.IO;
using System.Text;
using System.Management;

namespace MyService
{
	public partial class MyService : ServiceBase
	{
		private static String MyPath = System.AppDomain.CurrentDomain.SetupInformation.ApplicationBase;
		public MyService()
		{
			InitializeComponent();
			base.CanShutdown = true;
			base.CanStop = true;
			base.CanPauseAndContinue = false;
			base.AutoLog = false;
			base.ServiceName = System.IO.Path.GetFileNameWithoutExtension(System.Diagnostics.Process.GetCurrentProcess().MainModule.FileName);
			MyPath = System.AppDomain.CurrentDomain.SetupInformation.ApplicationBase + base.ServiceName;
		}

		private static Process cmd = null;
		protected override void OnStart(string[] args)
		{
			try
			{
				Process pro = new Process();
				pro.StartInfo.UseShellExecute = true;
				pro.StartInfo.WorkingDirectory = System.AppDomain.CurrentDomain.SetupInformation.ApplicationBase;
				pro.StartInfo.FileName = MyPath + ".bat";
				pro.StartInfo.CreateNoWindow = true;
				pro.StartInfo.WindowStyle = System.Diagnostics.ProcessWindowStyle.Hidden;
				pro.Start();
				cmd = pro;
			}
			catch (Exception ex)
			{
				string logFile = MyPath + "\\" + DateTime.Now.ToString("yyyy-MM-dd") + ".txt";
				CreatePath(logFile);
				WriteFile(logFile, string.Format("{0} [error] {1} [{2}]\r\n", DateTime.Now.ToString("yyyy-MM-dd HH:mm:ss"), ex.Message, MyPath + ".bat"), "UTF-8", false);
				try
				{
					if (cmd != null)
					{
						KillProcessAndChildren(cmd.Id);
					}
				}
				catch
				{
				}
				throw ex;
			}
		}

		protected override void OnStop()
		{
			try
			{
				if (cmd != null)
				{
					KillProcessAndChildren(cmd.Id);
				}
			}
			catch
			{
			}
			cmd = null;
		}

		private static void KillProcessAndChildren(int pid)
		{
			ManagementObjectSearcher searcher = new ManagementObjectSearcher("Select * From Win32_Process Where ParentProcessID=" + pid);
			ManagementObjectCollection moc = searcher.Get();
			foreach (ManagementObject mo in moc)
			{
				KillProcessAndChildren(Convert.ToInt32(mo["ProcessID"]));
			}
			try
			{
				Process proc = Process.GetProcessById(pid);
				if (!proc.HasExited)
				{
					proc.Kill();
				}
			}
			catch
			{
			}
		}

		private static Boolean CreatePath(String filePath)
		{
			String folder = Path.GetDirectoryName(filePath);// 取得当前路径下全路径（不以/结尾的无法区分是否文件夹，则取得父路径）
			if (!Directory.Exists(folder))
			{
				Directory.CreateDirectory(folder);
			}
			if (!Directory.Exists(filePath) || !File.Exists(filePath))
			{
				String parentFilePath = (new FileInfo(filePath)).DirectoryName;
				if (!Directory.Exists(parentFilePath))
				{
					Directory.CreateDirectory(parentFilePath);// 创建所属目录
				}
			}
			else if (Directory.Exists(filePath))// 不可覆盖或是目录时
			{
				return false;
			}
			return true;
		}
		private static Boolean WriteFile(String filePath, String content, String charsetName, Boolean overwrite)
		{
			Encoding enc = charsetName.ToLower().Equals("utf-8") ? new UTF8Encoding(false) : Encoding.GetEncoding(charsetName);
			using (StreamWriter sw = new StreamWriter(filePath, true, enc))
			{
				sw.Write(content);
				sw.Close();
			}
			return true;
		}
	}
}
